import * as React from "react";
import { PromiseExt } from "@0x2e757/promise-ext";
export { PromiseExt };
import { IWrapper, StaticWrapper, IStaticWrapper, DynamicWrapper, IDynamicWrapper } from "@0x2e757/wrappers";
export type { IWrapper, IStaticWrapper, IDynamicWrapper };
export { StaticWrapper, DynamicWrapper };
import { Constructor, ISubscribable } from "./types";
export type { Constructor, ISubscribable };
import { Form } from "./form";
export { Form };
import { Field } from "./field";
export { Field };
export declare const subscribe: (...subscribables: ISubscribable[]) => <T extends Constructor<React.Component<{}, {}, any>>>(component: T) => T;
export declare const useWrapper: <T>(wrapper: IStaticWrapper<T>) => [T, (value: T, debounce?: number | undefined) => void];
export declare const useSubscribable: <T>(wrapper: IWrapper<T>) => T;
export declare const useForm: <T>(name?: string) => Form<T>;
declare const _default: {
    PromiseExt: typeof PromiseExt;
    StaticWrapper: new <T>(value: T) => IStaticWrapper<T>;
    DynamicWrapper: new <T_1, U extends unknown[]>(...args: [...wrappers: import("@0x2e757/wrappers/build/types").IWrappers<U>, emitter: import("@0x2e757/wrappers/build/types").Emitter<T_1, U>]) => IDynamicWrapper<T_1>;
    Form: typeof Form;
    Field: typeof Field;
    subscribe: (...subscribables: ISubscribable<any>[]) => <T_2 extends Constructor<React.Component<{}, {}, any>>>(component: T_2) => T_2;
    useWrapper: <T_3>(wrapper: IStaticWrapper<T_3>) => [T_3, (value: T_3, debounce?: number | undefined) => void];
    useSubscribable: <T_4>(wrapper: IWrapper<T_4>) => T_4;
};
export default _default;
//# sourceMappingURL=index.d.ts.map